#!/bin/sh
# -*- mode: shell-script; sh-basic-offset: 8; tab-width: 8 -*-

#exec 2>>/tmp/vpnc.sh-$$.${1-start}; date >&2; set -x; : $0 "$@"; env >&2

set -eu

PATH='/sbin:/usr/sbin:/bin:/usr/bin'
export PATH

# both of these are useless -- well allowing users to use their own
# configurations is a feature.
#case `readlink /proc/$PPID/exe` in /opt/vpn9c/bin/vpn9c) ;; *) exit 1;esac
#case /proc/$PPID/cmdline in /opt/vpn9c/bin/vpn9c*) ;; *) exit 1 ;; esac

VPNC_MESSAGE_FILE=/var/run/vpnc/message
export VPNC_MESSAGE_FILE

# status is the most often called case: exit codes
#  0 -- running
# 10 -- not running (or finalizing)
# anything else -- starting (or in rare cases stopping)
case ${1-} in 'status')
	if pkill -0 vpnc 2>/dev/null
	then
		m=`awk '/^Stopping/ { print;exit }
			/^VPNC started/ { print;exit }' \
				$VPNC_MESSAGE_FILE 2>/dev/null` || :
		case $m in Stopping*) exit 10
		;;	'VPNC started'*) exit 0
		esac
		exit 1
	else
		exit 10
	fi
esac

# rest
case ${1-} in 'stop') pkill vpnc || pkill -HUP vpn9c; exit 0
;;	'') # normal start case -- without filename.
;;	*) ! test -f "$1" || exec 0<"$1"
esac

# start
cd /opt/vpn9c/bin

test -d /var/run/vpnc/ || mkdir /var/run/vpnc
#rm -f $VPNC_MESSAGE_FILE
exec 1>$VPNC_MESSAGE_FILE 2>&1

./vpnc --script 'exec /opt/vpn9c/bin/vpnc-script' - || :
exec pkill -HUP vpn9c
exit 1

cat > /tmp/vpnc-$$.conf
exec ./vpnc --script 'exec /opt/vpn9c/bin/vpnc-script' /tmp/vpnc-$$.conf
