// -*- css -*-

import QtQuick 1.1
import com.nokia.meego 1.0

//import 'devtools.js' as DT

Column {
    id: conf
    anchors.centerIn: parent
    spacing: 12

    property bool startpending: false

    function haveSaveButton(flag) {
	if (flag) {
	    loadsave.text = 'Save'
	    loadsave.enabled = true
	    remreset.text = 'Reset'
	    remreset.enabled = true
	}
	else {
	    loadsave.text = 'Load'
	    loadsave.enabled = ! loadsave.loaded
	    remreset.text = 'Remove'
	    remreset.enabled = false
	}
    }

    function start() {
	if (startbutton.text == 'Stop') {
	    startbutton.enabled = false
	    cxx.stopVpnc()
	    return
	}
	if (gwy.txt == '') {
	    _alert("'Gateway' not configured!")
	    return
	}
	if (gna.txt == '') {
	    _alert("'Group Name' not configured!")
	    return
	}
	if (gpw.txt == '') {
	    _alert("'Group Pwd' not configured!")
	    return
	}
	if (una.txt == '') {
	    _alert("'Username' not configured!")
	    return
	}
	if (pwd.txt == '') {
	    if (startpending) {
		startpending = false
		return
	    }
	    startpending = true
	    pwd.pop()
	    return
	}
	var _pwd = pwd.txt
	if (startpending) {
	    pwd.reset()
	    startpending = false
	}
	vpncStatus(256, false)
	cxx.runVpnc(gwy.txt, gna.txt, gpw.txt, una.txt, _pwd, dom.txt)
    }

    Text {
	anchors.horizontalCenter: parent.horizontalCenter
	text: 'Configuration'
	font.pixelSize: 40
	color: '#e0e1e2'
    }

    FixedEntryRow { id: gwy; name: 'gateway'; label: 'Gateway' }
    FixedEntryRow { id: gna; name: 'groupname'; label: 'Group Name' }
    FixedEntryRow { id: gpw; name: 'grouppwd'; label: 'Group Pwd'; pwMode: -1 }
    FixedEntryRow { id: una; name: 'username'; label: 'Username' }
    FixedEntryRow { id: pwd; name: 'password'; label: 'Password'; pwMode: 1 }
    FixedEntryRow { id: dom; name: 'domain'; label: 'Domain' }

    Row {
	spacing: 10
	anchors.horizontalCenter: parent.horizontalCenter

	Button {
	    iconSource: 'image://theme/icon-m-toolbar-previous-dimmed-white'
	    //iconSource: 'image://theme/icon-m-toolbar-previous-white'
	    width: 80
	    enabled: false
	    onClicked: console.log('prev')
	}
	Button {
	    iconSource: 'image://theme/icon-m-toolbar-next-dimmed-white'
	    //iconSource: 'image://theme/icon-m-toolbar-next-white'
	    width: 80
	    enabled: false
	    onClicked: console.log('next')
	}
	Button {
	    id: loadsave
	    text: 'Load'
	    width: 120
	    enabled: true // false
	    property bool loaded: false
	    onClicked: {
		//DT.introspect(conf)
		if (text == 'Save') {
		    if (cxx.saveConfig(gwy.txt, gna.txt, gpw.txt,
				       una.txt, dom.txt)) {
			// Qt.findChildren() (or something) could be useful...
			for (var i = 0; i < conf.children.length; i++) {
			    var obj = conf.children[i]
			    if (obj.objectName == 'fixedEntryRow') obj.saved()
			}
			haveSaveButton(false)
		    }
		}
		else { // load
		    if (! cxx.importPcf(cxx.defaultPcf())) {
			loaded = true
			haveSaveButton(false)
			return
		    }
		    for (var i = 0; i < conf.children.length; i++) {
			var obj = conf.children[i]
			if (obj.objectName == 'fixedEntryRow') obj.reset()
		    }
		}
	    }
	}
	Button {
	    id: remreset
	    text: 'Remove'
	    width: 120
	    enabled: false
	    onClicked: {
		if (text == 'Reset') {
		    for (var i = 0; i < conf.children.length; i++) {
			var obj = conf.children[i]
			if (obj.objectName == 'fixedEntryRow') obj.reset()
		    }
		    haveSaveButton(false)
		}
		else { // remove
		    console.log(text)
		}
	    }
	}
    }
}
