// -*- css -*-

import QtQuick 1.1
import com.nokia.meego 1.0

Row {
    id: row
    property string name: ''
    property string label: ''
    property int pwMode: 0

    property alias txt: text.rtxt

    objectName: 'fixedEntryRow'

    function reset() {
	rect.update(cxx.getString(row.name))
	rect.border.color = 'blue'
    }
    function saved() {
	rect.border.color = 'blue'
    }

    function pop() { mousearea.clicked(Qt.LeftButton) }

    Text { width: 180; text: row.label; font.pixelSize: 26; color: '#e0e1e2' }

    Rectangle {
	id: rect
	width: 250
	height: 35
	color: 'white'
	border.color: 'blue'
	border.width: 2
	radius: 15

	Text {
	    id: text
	    property string rtxt: ''
	    anchors.left: parent.left
	    anchors.leftMargin: 9
	    anchors.verticalCenter: parent.verticalCenter
	    font.pixelSize: 26
	    textFormat: Text.PlainText
	    color: '#000000'

	    Component.onCompleted: {
		rect.setTextText(false, cxx.getString(row.name))
	    }
	}
	MouseArea {
	    id: mousearea
	    anchors.fill: parent

	    onClicked: {
		var component = Qt.createComponent('entrydialog.qml')
		if (component.status == Component.Ready) {
		    var dialog = component.createObject(
			toplevel, { label: row.label,
				     text: row.pwMode != 0? '': text.text,
				     echoMode: row.pwMode == 0?
						0: TextInput.Password,
				     caller: rect } )
		}
		else
		    console.log(component.errorString())
	    }
	}
	function update(texxt) {
	    rect.setTextText(true, texxt)
	}
	function setTextText(update, texxt) {
	    if (update && row.pwMode <= 0) {
		rect.border.color = 'yellow'
		conf.haveSaveButton(true)
	    }
	    text.rtxt = texxt
	    if (row.pwMode == 0 || texxt == '')
		text.text = texxt
	    else
		text.text = '**********'
	}
    }
}
