// -*- css -*-

import QtQuick 1.1
import com.nokia.meego 1.0

// used entrydialog.qml for reference...

// this could have states & transitions to brighten the text
// and when fully bright, mousearea click would be active.

Rectangle {
    id: alert
    z: 10

    property string text: ''

    anchors.fill: toplevel

    color: 'black'
    opacity: 0.85

    // capture all input outside...
    MouseArea {
	anchors.fill: parent
	onClicked: alert.destroy()
    }

    Rectangle {
	id:rect
	height: text.height + 10
	width: parent.width + 6
	color: 'black'
	border.color: '#805858'
	opacity: 1 // mixes with parent opacity...
	anchors.centerIn: parent
	z: 20
    }
    Text {
	id: text
	opacity: 1 // mixes with parent opacity...
	anchors.horizontalCenter: parent.horizontalCenter
	//anchors.verticalCenter: parent.verticalCenter
	y: rect.y + 4 // one pixel line makes a difference...
	z: 21
	text: alert.text
	textFormat: Text.PlainText
	width: 840 // hardcoded :/
	wrapMode: Text.Wrap
	font.pixelSize: 40
	color: '#ffb1b2'
    }

    // thanks to stackoverflow.com/questions/6345164/qml-text-wrap-max-width
    Component.onCompleted: {
	if (text.paintedWidth < 840) {
	    text.width = text.paintedWidth
	}
    }
}
