// -*- css -*-

import QtQuick 1.1
import com.nokia.meego 1.0

// Used http://projects.forum.nokia.com/QMLTemplates for reference

Rectangle {
    id: dialog
    z: 10

    property string label: ''
    property string text: ''
    property int echoMode: 0
    property Item caller: null

    anchors.fill: toplevel

    color: 'black'
    opacity: 0.85

    // capture all input outside...
    MouseArea {	anchors.fill: parent }

    Rectangle {
	height: 180
	width: 500
	color: 'black'
	opacity: 1 // mixes with parent opacity...
	z: 20
	radius: 10
	anchors.horizontalCenter: parent.horizontalCenter
	anchors.top: parent.top
	anchors.topMargin: 50

	Row {
	    anchors.horizontalCenter: parent.horizontalCenter
	    anchors.top: parent.top
	    anchors.topMargin: 25
	    spacing: 10

	    Text { text: dialog.label; font.pixelSize: 35; color: '#e0e1e2' }
	    TextField {
		id: text; text: dialog.text; maximumLength: 32
		focus: true; echoMode: dialog.echoMode
		inputMethodHints: Qt.ImhNoAutoUppercase|Qt.ImhNoPredictiveText
		//Keys.onReturnPressed: text.platformCloseSoftwareInputPanel()
	    }
	}

	//ButtonRow {
	Row {
	    id: buttons
	    anchors.horizontalCenter: parent.horizontalCenter
	    anchors.bottom: parent.bottom
	    anchors.bottomMargin: 25
	    spacing: 25

	    Button {
		text: 'OK'; width: 180
		onClicked: buttons.clicked(true)
	    }
	    Button {
		text: 'Cancel'; width: 180
		onClicked: buttons.clicked(false)
	    }
	    function clicked(update) {
		if (update)
		    caller.update(text.text)
		text.platformCloseSoftwareInputPanel()
		dialog.destroy()
		if (conf.startpending)
		    conf.start()
	    }
	}
    }
}
