// -*- css -*-

import QtQuick 1.1
import com.nokia.meego 1.0

PageStackWindow {
    id: toplevel

    Component.onCompleted: {
	theme.inverted = true
    }

    function _alert(text) {
	var component = Qt.createComponent('alert.qml')
	if (component.status == Component.Ready)
	    component.createObject(toplevel, { text: text } )
	else
	    console.log(component.errorString())
    }

    function _about() {
	var component = Qt.createComponent('about.qml')
	if (component.status == Component.Ready)
	    component.createObject(toplevel)
	else
	    console.log(component.errorString())
    }

    function vpncStatus(status, initial) {
	if (status == 0) {
	    startcircle.color = '#008800'
	    startbutton.text = 'Stop'
	}
	else if (status == 2560) {
	    if (! initial) {
		var msg = cxx.getVpncMsg()
		if (msg) _alert(msg)
	    }
	    startcircle.color = '#c00000'
	    startbutton.text = 'Start'
	    startbutton.enabled = true
	}
	else {
	    startcircle.color = '#c0c000'
	    startbutton.text = 'Stop'
	}
    }

    initialPage: appPage

    Page {
	id: appPage

	// Automatic in simulator, LockLandscape on device.
	// Also keep in sync with main.cpp (i.e. landscape setting for device).
	orientationLock: PageOrientation.LockLandscape

	Button {
	    anchors.left: parent.left
	    anchors.leftMargin: -70
	    anchors.verticalCenter: parent.verticalCenter

	    text: 'VPN9C'
	    rotation: -90
	    height: 68
	    font.pixelSize: 60
	    //font.bold: false
	    font.weight: Font.Normal
	    //color: '#e0e1e2'

	    onClicked: {
		var component = Qt.createComponent('about.qml')
		if (component.status == Component.Ready)
		    component.createObject(toplevel)
		else
		    console.log(component.errorString())
	    }
	}

	Configuration {	id: conf }

	// circle
	Rectangle {
	    id: startcircle
	    anchors.right: parent.right
	    anchors.rightMargin: 75
	    anchors.top: parent.top
	    anchors.topMargin: 100

	    color: '#000000'
	    height: 60
	    width: 60
	    radius: 30
	}
	Button {
	    id: startbutton
	    anchors.right: parent.right
	    anchors.rightMargin: 60
	    anchors.bottom: parent.bottom
	    anchors.bottomMargin: 100
	    text: ''
	    height: 90
	    width: 90
	    rotation: -45
	    onClicked: conf.start()
	}
	Component.onCompleted: vpncStatus( cxx.vpncStatus(), true )
    }
}
